Skip to main content Skip to footer

Best Practices for Vue Developers in 2021

  • 0 Comments

Vue JS is famous for its innovative JavaScript framework that enables us to build responsive, high-performing, feature-rich, and beautiful frontends. Additionally, Vue equips developers with the power to create a wide range of powerful web applications with its single-page apps (SPA) and server-side rendering (SSR) capabilities.

In this article, we’ll explore some of the best practices every Vue developer should adopt to help us write quality code, become better developers, and build better applications.

GrapeCity Provides Premium JavaScript Solutions

Including SpreadJS and Wijmo

Check them out today!

Audit Packages Regularly

It's not new knowledge that third-party packages can introduce security vulnerabilities into our applications. Auditing these packages regularly to find and fix any vulnerabilities ensures that our applications remain secure.

  • Every Vue developer should have a dependency audit process (DAP) checklist deployed in their projects.
  • To audit dependency packages:

    • Check for vulnerabilities with npm audit. This command will produce a report of dependency vulnerabilities and, if available, suggested patches.
    • Review the audit report and run recommended commands like npm audit fix, or investigate further and manually fix vulnerabilities if needed.
    • Check for outdated packages with npm obsolete and try to update them with the npm update command.

Best Practices for Vue Developers in 2021

Organize HTTP Requests Using the API Module Pattern

Let’s imagine we’re building a shopping cart app. We’d have to make a lot of HTTP requests to get data from API endpoints. While it's not wrong to bundle all that code inside a component, it’s better to abstract HTTP requests by modularizing them with the API module pattern.

Abstracting HTTP requests ensures that the UI component focuses on the UI rather than business logic. Eventually, as the lines of codes expand, the codebase does not get too complex.

The API module is a JavaScript module that has all HTTP logic categorized by resource. In our app, our resources are Product, Cart, Orders, and so on. For example, say we wanted to display all the products in the cart. We’ll begin by creating an API directory and add a product.js file. Here’s how the API module looks:

//api/product.js  
export const async fetchProducts = () => {  
 const response = await axios.get("/api/products");  
 return response;  
}  

//api/product.js  
export const async addToCart = (itemId, qty) {  
 const payload = JSON.stringify({ itemId, qty });  
 const response = await axios.post("/api/cart", {  
  body: payload  
 });  
 const body = await response.json();  
 return body;  
}

Next, we import the modules both modules into components:

//~/components/AllProducts.vue  
import {fetchProducts, addToCart} from '~/api/product.js'

const getAllProducts = () => {  
 try {  
  const response = fetchProducts()  
  ....  
 }  
 catch {}  
}  

const createNewProduct = () => {  
 try {  
  const response = addToCart()  
 }  
 catch {}  
}

Use JSDoc to Document API Endpoints

JSDoc is an open-source API documentation generator that allows us to document our code using comments.

Documenting API endpoints is crucial as it makes everybody's lives easier. It decreases the amount of time (and confusion) spent on understanding how the API works and deciphering unexpected errors when old and new team members alike use it.

While JSDoc isn’t the only documentation tool out there, it's open-source, deeply integrated, and supported by popular code editors like VS Code. To add JSDoc to our project, install JSDoc as follows:

//bash  
npm install --save-dev jsdoc 

Next, create a jsdoc.json file and add these lines of code:

//jsdoc.json  
{  
 "source": {  
  "include": [ "src/", "api/" ],  
  "exclude": [ "src/router" ]  
 },  
 "opts": {  
  "template": "node_modules/docdash",  
  "encoding": "utf8",  
  "destination": "./docs/",  
  "recurse": true,  
  "verbose": true  
 }  
}  

Then, modify package.json to look like this:

//package.json  
"scripts": {  
 "dev": "vue-cli-service serve",  
 "build": "vue-cli-service build",  
 "generate:doc": "jsdoc -c ./jsdoc.json",  
},

Use comments to document the JavaScript.

// api/product.js  
/*  
 *Add product to cart  
  * @param itemID {String} is the id of the product  
  * @param qty {Number} is an integer depicting the quantity of products  
 * @returns {object}  
*/  
export const async addToCart = (itemId, qty) {  
 const payload = JSON.stringify({ itemId, qty });  
 const response = await axios.post("/api/cart", {  
  body: payload  
 });  
 const body = await response.json();  
 return body;  
}

Finally, generate a documentation page by running this command:

npm run generate:doc  

This practice not only saves you a lot of time but also ultimately boosts your workflow.

Use Refs for DOM Manipulation

Performing DOM manipulation is not a good idea because Vue abstracts most of those things. However, if we must manipulate the DOM, then refs are the solution.

In Vue, refs is a special attribute used to register a reference to an element or a child component. One popular case is trying to add focus to an input element. Instead of targeting the element using vanilla JavaScript, use $refs with this .$refs.input.focus().

//vuejs  
const app = Vue.createApp({})  
app.component('base-input', {  
 template: `  
  <input ref="input" />  
 `,  
 methods: {  
  focusInput() {  
   this.$refs.input.focus()  
  }  
 },  
 mounted() {  
  this.focusInput()  
 }  
})

Best Practices for Vue Developers in 2021

Refactor Big Components into Smaller Reusable Components

Reusable components are components that you can use anywhere in your application. As a result, they must be generic enough so that they are free from business logic. When planning component organization, you should consider reusable components.

When we repeat code too much in JavaScript, we refactor it to become a function so it becomes reusable, right? In Vue, when a component becomes too big, we should refactor it into smaller reusable components. Doing this saves time, makes the project more readable and maintainable.

Steer Clear of Cross-site Scripting Mistakes

Cross-site Scripting attacks the data integrity of trusted websites and applications by injecting malicious code into the webpage. If we allow HTML, JavaScript, or CSS code to execute impure, user-provided content, we might be opening our projects up to attacks.

Some common mistakes that Vue developers make that make our applications prone to XSS attacks include:

  • Using v-HTML for rendering text. Instead, use as many interpolated expressions {{}} as you can. The browser can’t execute anything in {{}} because they are ordinary strings. But, if you ever must use v-HTML, ensure to parse the string and escape characters.
  • Using third-party UI libraries that use v-HTML to render data passed through props. To ensure you sanitize your HTML, use vue-sanitize — a whitelist-based HTML sanitizer (sanitize-HTML) for Vue.js apps.

Don’t Rely Heavily on Third-Party Libraries

When it comes to personal security, we're wary of inviting a stranger into our homes because we don't know their backgrounds, who they are, or what they’re capable of doing. It should be the same with our codebase. For example, we shouldn't install a library to parse strings when we can write our own custom directive or plugin or instance property (try not to pollute the global scope).

This practice works in tandem with the previous one because most of these packages contain malicious code that can mess up our project. Reducing dependence on third-party UI libraries also boosts the performance of our frontend.

The point here isn't to avoid using third-party libraries. It’s to make sure the functionality provided by the library is something that we do need and can’t write on our own — for example, date and time parsers.

Before adding a third-party library to our project, we should write a pros and cons list. If the pros are more significant than the cons, we must confirm that the package does not open our application to security or technical risks.

To confirm that the package doesn’t open our application to security or technical risks, begin by checking the last published date, weekly downloads, and collaborators' profile of the library to ensure they indicate active maintenance. Then, test the package for security vulnerabilities with the Synk open-source security testing tool. After that, check the performance cost of adding that library to our project using the bundlephobia tool. If all these checks yield negative results, then we should consider alternative tools.

Use Kebab Case for Custom Event Names

This is probably the most overlooked practice when writing Vue. Even though event names are not case sensitive, it’s best practice to use the kebab case. This is because the listener event name’s casing must match the emitter event name casing.

Smashed-up lower-case names work fine, but they are less readable than kebab case. Also, do not use camel case for event naming because an emitted event named this <.$emit(myAge)> is not going to work if your listener event name is in kebab case like this <component> v-on:my-age="tell my age"> <component>.

The thing about following best practices is that they are easy to forget or overlook. That's why eslint is very important in any Vue project. We can use the vue/custom-event-name-casing eslint plugin to enact a style for custom event name casing for consistency purposes.

Include Keys in v-for Components

By default, if you use VS Code and Vetur (the official tooling extension for VS Code), you get error messages when you don't include a unique key in a v-for element. This is a priority rule with Vue.

The <:key> attribute helps Vue's virtual DOM better identify each element on the list or the difference between an older node list and a newer one. The most common use case is with list rendering, especially when mapping an array to elements with v-for.

//vue  
<ul id="football-example">  
 <li v-for="footballer in footballers" :key="footballer.id">  
  \{{ footballer.name }}  
 </li>  
</ul>  

If you don't use VS Code and Vetur, the eslint plugin vue/require-v-for-key will assist in reporting the elements which have v-for and do not have <v-bind:key> except for custom components.

Validate Props with Custom Validators

A common rule in programming is to write predictable code. Predictable code means that our code is easy to understand by just reading it. Writing a custom props validator is one of the ways of achieving code predictability in Vue. It’s essential that when there's data communication between components or any two entities, they should validate that data to gain expected behavior.

Vue natively implements prop data security by providing type checking, validation, default values, and constraints to props. So why all this fuss about prop validation if they are type checks and default values? User behavior isn't predictable. That's why validating props, writing type checks, constraints, and default values ensure that we have a robust defense against malicious attacks and unpredictable edge cases. One typical case is when an object finds a way to bypass our type checks.

A custom prop validator is a function that accepts the value as input and returns a Boolean as validity status. Let's go through an example where we use a validator to check if a user isn’t from Nigeria.

//childComponent.vue  
<template>  
 <div>\{{ userInfo }}</div>  
</template>  
<script>  
 export default {  
  data: () => ({}),  
  props: {  
   userInfo: {  
    type: String,  
    required: true,  
    validator: val => val.location != "Nigeria"  
   }  
  }  
 };  
</script>  

//parentComponent.vue  
<!-- Caller -->  
<template>  
 <div>  
   <PropReceiverComponent :userInfo="user"></PropReceiverComponent>  
 </div>  
</template>  
<script>  
 import PropReceiverComponent from "~/components/PropReceiverComponent";  
 export default {  
  data: () => ({  
   user: {  
    location: "Nigeria"  
   }  
  }),  
  components: {  
   PropReceiverComponent  
  }  
 };  
</script>

Best Practices for Vue Developers in 2021

Conclusion

Newbie Vue developers should be pragmatic — just make things work and refactor in the future. But, as time goes on, the responsibilities start growing, and then developers must be concerned with design patterns, performance, test automation, accessibility, and so on. Maintaining best practices improves our code quality.

Rules like using a unique key in v-for components are mandatory because it's an essential Vue code practice. Other rules such as auditing packages regularly, reducing the use of third-party libraries, and avoiding XSS mistakes are vital to your project's security. You can learn more about these rules using the Vuejs Style guide.

Also, if you're ever working on an enterprise Vue project that requires you to implement robust reports, spreadsheets, charts, and tables, you don't have to build from scratch anymore. GrapeCity (with over 40 years of experience and expertise in this field) has the Vuejs tools you need to implement those features:

  • Wijmo, which provides a collection of UI components and responsive data grids for Vuejs projects. You can learn how to use Wijmo's Vue components with your project here.
  • SpreadJS, which is the world-leading UI library for building spreadsheets with over 500 Excel functions for your enterprise applications. You can learn how to integrate and use Spreadjs with your project here.
  • DataViewsJS, which is a JavaScript data visualization tool that helps customize data presentation using different layouts, row templates, data fields, calculations, and editing modes, that are completely and easily customizable. You can learn how to integrate and use dataviewjs with your project here.
  • ActiveReportsJS, which is a data visualization solution that offers developers the ability to customize report layouts and integrate the reports designer and components to your JavaScript project. You can learn how to integrate and use ActiveReports with your project here.

Be sure to check out GrapeCity’s Vue-compatible products, and drop any questions or suggestions on more best practices in the comments section below!

GrapeCity Provides Premium JavaScript Solutions

Including SpreadJS and Wijmo

Check them out today!
Chris Bannon - Global Product Manager

Chris Bannon

Global Product Manager of Wijmo

Skip to main content Skip to footer

Best Practices for React Developers in 2021

  • 0 Comments

It may be hard to believe, but this year React turned eight years old. In the technology landscape, especially on client-side web development, this is quite remarkable. How can a simple library for building UIs be that old and still be this relevant?

The reason is, React not only revolutionized the building of UIs, but it also made functional paradigms for building UIs popular. And even then, React did not stop there. They continued to push innovative concepts forward without breaking the existing codes. As a result, React is stabler, leaner, and faster than ever.

But, the downside of React's ever-evolving nature is that best practices change over time. To harvest some of the newest performance benefits, one needs to carefully study the new additions. And figuring that out is not always easy, sometimes it's not straightforward at all.

In this article, we will take a look at the best practices that apply to React in 2021.

GrapeCity Provides Premium JavaScript Solutions

Including SpreadJS and Wijmo

Check them out today!

Conventions

To structure your work with React, it makes sense to follow a few conventions. Some conventions are even required for the tooling to work smoothly. For example, if you name your components using camelCase, then the following would not work:

const myComponent = () => <div>Hello World!</div>;

ReactDOM.render(<myComponent />, document.querySelector('#app'));

This is because the standard JSX transformer from Babel (or TypeScript) uses the naming convention to decide whether to pass a string or an identifier to React.

As a result, the transpiled code would look as follows:

const myComponent = () => React.createElement("div", null, "Hello World!");

ReactDOM.render(React.createElement("myComponent", null), document.querySelector('#app'));

This is not what we want. Instead, we can use PascalCase. In this case, the JSX transformer will detect the usage of a custom component and the required reference.

const MyComponent = () => <div>Hello World!</div>;

ReactDOM.render(<MyComponent />, document.querySelector('#app'));

In this case, everything is fine:

ReactDOM.render(React.createElement(MyComponent, null), document.querySelector('#app'));

While other conventions are less strict, they should be still followed. For instance, it makes sense to use quoted string attributes instead of JSX expressions:

// avoid
<input type={'text'} />

// better
<input type="text" />

Likewise, it makes sense to keep the attribute quote style consistent. Most guides will propagate using single-quoted strings in JS expressions, and double-quoted strings for these React props. In the end, it doesn’t matter as long as its usage within the codebase is consistent.

Speaking of conventions and props, these should also follow the standard JS naming convention of using camelCase.

// avoid
const MyComponent = ({ is_valid, Value }) => {
  // ...
  return null;
};

// better
const MyComponent = ({ isValid, value }) => {
  // ...
  return null;
}; 

Additionally, be sure not to misuse the names of the built-in HTML component props (for example, style or className). If using these props, forward them to the respective in-built component. Also, keep them at the original type (for example, for style a CSS style object and for className a string).

// avoid
const MyComponent = ({ style, cssStyle }) => {
  if (style === 'dark') {
    // ...
  }

  // ...
  return <div style={cssStyle}>...</div>;
};

// better
const MyComponent = ({ kind, style }) => {
  if (kind === 'dark') {
    // ...
  }

  // ...
  return <div style={style}>...</div>;
};

This makes the intention of the props much clearer and establishes a consistency level that is critical for efficient usage of larger component collections.

Component Separation

One of React's biggest advantages is its ability to easily test and reason about components. However, this is only possible if a component is small and dedicated enough to support that.

Back when React first started gaining popularity, they introduced the concept of a controller and a view component to efficiently structure larger components. Even though today we have dedicated state containers and hooks, it still makes sense to structure and categorize components in some way.

Let's consider the simple example of loading some data:

const MyComponent = () => {
  const [data, setData] = React.useState();

  React.useEffect(() => {
    let active = true;

    fetch('...')
      .then(res => res.json())
      .then(data => active && setData(data))
      .catch(err => active && setData(err));


    return () => {
      active = false;
    };
  }, []);

  return (
    data === undefined ?
      <div>Loading ...</div> :
      data instanceof Error ?
        <div>Error!</div> :
        <div>Loaded! Do something with data...</div>
  );
};

Of course, a componentless action would be better suited here. But the point is that the written component has to both gather the data and display it.

A cleaner model would imply a separation that could look like this:

const MyComponent = ({ error, loading, data }) => {
  return (
    loading ?
      <div>Loading ...</div> :
      error ?
        <div>Error!</div> :
        <div>Loaded! Do something with data...</div>
  );
};

const MyLoader = () => {
  const [data, setData] = React.useState();

  React.useEffect(() => {
    let active = true;

    fetch('...')
      .then(res => res.json())
      .then(data => active && setData(data))
      .catch(err => active && setData(err));

    return () => {
      active = false;
    };
  }, []);

  const isError = data instanceof Error;

  return (
    <MyComponent
      error={isError ? data : undefined}
      loading={data === undefined}
      data={!isError ? data : undefined} />
  );
};

To further improve it, the most ideal separation is extraction into a custom hook:

function useRemoteData() {
  const [data, setData] = React.useState();

  React.useEffect(() => {
    let active = true;

    fetch('...')
      .then(res => res.json())
      .then(data => active && setData(data))
      .catch(err => active && setData(err));

    return () => {
      active = false;
    };
  }, []);

  const isError = data instanceof Error;

  return [data === undefined, !isError ? data : undefined, isError ? data : undefined];
}

const MyComponent = () => {
  const [loading, data, error] = useRemoteData();

  return (
    loading ?
      <div>Loading ...</div> :
      error ?
        <div>Error!</div> :
        <div>Loaded! Do something with data...</div>
  );
}; 

Hooks

React hooks are among the most debated technology features in the frontend space. When they were first introduced, they were considered elegant and innovative. On the flip side, there have been a growing number of critics over the years.

Pros and cons aside, in general, using hooks can be a best practice depending on the scenario.

Keep in mind that some hooks are there to help you with performance optimizations:

  • useMemo helps avoid doing expensive calculations on every re-render.
  • useCallback produces stable handlers, similarly to useMemo, but more conveniently geared towards callbacks.

As an example, let’s look at the following code without useMemo:

const MyComponent = ({ items, region }) => {
  const taxedItems = items.map(item => ({
      ...item,
      tax: getTax(item, region),
  }));

  return (
      <>
        {taxedItems.map(item => <li key={item.id}>
          Tax: {item.tax}
        </li>)}
      </>
  );
};

Considering there might be a lot of items in that array, and that the getTax operation is quite expensive (no pun intended), you’d have quite a bad re-rendering time, assuming minimal items and region change.

Therefore, the code would benefit a lot from useMemo:

const MyComponent = ({ items, region }) => {
  const taxedItems = React.useMemo(() => items.map(item => ({
      ...item,
      tax: getTax(item, region),
  })), [items, region]);

  return (
      <>
        {taxedItems.map(item => <li key={item.id}>
          Tax: {item.tax}
        </li>)}
      </>
  );
}; 

The beauty of useMemo is that it's almost invisible. As you can see, all we need to do is to wrap the computation in a function. That's it. No other changes required.

A more subtle issue is the lack of useCallback. Let's have a look at some very generic code:

const MyComponent = () => {
  const save = () => {
    // some computation
  };
  return <OtherComponent onSave={save} />;
}; 

Now, we don't know anything about OtherComponent, but there are certain possible changes originating here, for example:

  • It’s a pure component and will prevent re-rendering, as long as all props remain untouched.
  • It uses the callback on either some memoization or effect hooks.
  • It passes the callback to some component that uses one of these properties.

Either way, passing values as props that essentially have not changed should also result in values that have not changed. The fact that we have a function declared inside our rendering function will be problematic.

An easy way out is to write the same thing using useCallback:

const MyComponent = () => {
  const save = React.useCallback(() => {
    // some computation
  }, []);
  return <OtherComponent onSave={save} />;
};

Now, the recomputed callback is taken only if one of the dependencies given in the array changed. Otherwise, the previous callback (for instance, a stable reference) is returned.

Like before, there are almost no code changes required for this optimization. As a result, you should always wrap callbacks using useCallback.

Components

Speaking of pure components, while class components had the PureComponent abstraction, a functional pure component can be introduced to React explicitly using memo.

// no memoed component
const MyComponent = ({ isValid }) => (
  <div style=\{{ color: isValid ? 'green' : 'red' }}>
    status
  </div>
);

// memoed component
const MyComponent = React.memo(({ isValid }) => (
  <div style=\{{ color: isValid ? 'green' : 'red' }}>
    status
  </div>
));

The React documentation is quite detailed about memo. It says: “If your component renders the same result given the same props, you can wrap it in a call to React.memo for a performance boost in some cases by memoizing the result. This means that React will skip rendering the component, and reuse the last rendered result.”

Keep in mind that — like any other comparison done by React — the props are only shallowly compared. Therefore, this optimization is only applied if we are careful what to pass in. For instance, if we use useMemo and other techniques for complex props such as arrays, objects, and functions.

You may have noticed that we exclusively used functional components. As a matter of fact, since the introduction of hooks, you can practically work without class components.

There are only two possible reasons to still use class components:

  1. You want to have access to the more sophisticated life cycle events. For example, shouldComponentUpdate.
  2. You want to introduce error boundaries.

However, even in these cases, you might just need to write one React class component to fulfill your needs. Look at this boundary:

export class Boundary extends React.Component {
  state = {
    error: undefined,
  };

  componentDidCatch(error) {
    this.setState({
      error,
    });
  }

  render() {
    const { error } = this.state;
    const { children, ShowError } = this.props;

    if (error) {
      return <ShowError error={error} />;
    }

    return children;
  }
}

Not only will the component catch any errors which may appear in its children, but it will also display a fallback component passed in as ShowError receiving a single prop: the error.

Operators

Some operators can be used to simplify the tree construction in React. For instance, the ternary operator allows us to write code that looks like this:

<div>
  {currentUser ? <strong>{currentUser}</strong> : <span>Not logged in</span>}
</div> 

Boolean operators such as && and || may also be useful, but there are a few traps to watch out for. As an example, look at this code snippet:

<div>
  {numUsers && <i>There are {numUsers} users logged in.</i>}
</div>

Assuming that numUsers is always a number between 0 and the total number of users, we'd end up with the expected output if numUsers is positive.

<div>
  <i>There are 5 users logged in.</i>
</div>

However, for the edge case of zero users, we'd get this:

<div>
  0
</div>

Which may not be what we wanted, so a boolean conversion or more explicit comparison could help here. In general, the following is more readable:

<div>
  {numUsers > 0 && <i>There are {numUsers} users logged in.</i>}
</div> 

Now, in the zero users edge case scenario we get:

<div>
</div>

Using the ternary operator as an exclusive boolean operator avoids the issue completely. But what about a state where we don't want to render anything? We could either use false or an empty fragment:

<div>
  {numUsers ? <i>There are {numUsers} users logged in.</i> : <></>}
</div> 

The empty fragment has the advantage of giving us the ability to just add content later. However, for users less familiar with React, it could look a bit strange.

Conclusion

In this article, we went over some of the best practices that make your React codebase easier to work with. By switching over from class components to functional components, you can dive more into hooks. This will provide the ability to automatically introduce a great separation of concerns, where the behavioral aspects are all done in functions and rendering is defined within components.

By following a set of useful conventions, together with some techniques such as the use of the right operators, hooks, and separation of concerns, you should end up with a clean codebase that can be maintained and extended quite easily.

Of course, the best way to use these best practices is to exclusively use components that already follow them. For example, with GrapeCity's React-compatible products, you will always be in good hands. Learn more on GrapeCity’s Wijmo product page.

GrapeCity Provides Premium JavaScript Solutions

Including SpreadJS and Wijmo

Check them out today!

Joel Parks - Product Manager

Joel Parks

Product Manager